#include "car.h"

car::car(CarColor color, int velocity, int defaultPos, Direction direction, int startTime) : 
    color(color), velocity(velocity), defaultPos(defaultPos), direction(direction), startTime(startTime), 
    currentPos(defaultPos), waiting(false), laps(0), firstLapTime(0), energy(0), waiting_previous(true), waitingTime(0)
{
}

car::~car()
{
}

int car::convertDegree(int deg)
{
    int tempDeg = deg % 360;
    while (tempDeg < 0)
    {
        tempDeg += 360;
    }
    return tempDeg;
}

int car::nextPos()
{
    if (waiting)
    {
        if (waiting_previous == false) energy += 5;
        waiting_previous = true;
        waitingTime++;
        return currentPos;
    }
    else
    {
        if (waiting_previous == true) energy += 8;
        waiting_previous = false;

        energy += 2 * velocity;

        int tempPos = currentPos;
        if (direction == Direction::Positive)
        {
            tempPos += velocity;
        }
        else
        {
            tempPos -= velocity;
        }
        tempPos = convertDegree(tempPos);
    }
}

void car::step(int currentTime)
{
    if (currentTime > startTime)
    {
        int tempPos = nextPos();
        if (currentPos != defaultPos && tempPos == defaultPos)
        {
            laps++;
            if (laps == 1) firstLapTime = currentTime - startTime;
        }
        currentPos = tempPos;
    }
}

CarColor car::getColor()
{
    return color;
}

int car::getVelocity()
{
    return velocity;
}

int car::getCurrentPos()
{
    return currentPos;
}

Direction car::getDirection()
{
    return direction;
}

int car::getStartTime()
{
    return startTime;
}

bool car::getWaiting()
{
    return waiting;
}

int car::getLaps()
{
    return laps;
}

int car::getFirstLapTime()
{
    return firstLapTime;
}

int car::getEnergy()
{
    return energy;
}

void car::setWaiting(bool input)
{
    waiting = input;
}

int car::getWaitingTime()
{
    return waitingTime;
}