#pragma once
enum CarColor
{
    Blue = 0,
    Yellow = 1,
    Black = 2,
    Green = 3,
    Red = 4,
    WrongColor = 5
};

enum Direction
{
    Positive = 0,
    Negative = 1,
    WrongDir = 2
};

class car
{
public:
    car(CarColor color, int velocity, int defaultPos, Direction direction, int startTime);
    ~car();

    //Give the next position of the car, based on the waiting flag, and velocity
    int nextPos();
    //The currentPos is updated with one step
    void step(int currentTime);

    //Getter functions for the attributes of the class
    CarColor getColor();
    int getVelocity();
    int getCurrentPos();
    Direction getDirection();
    int getStartTime();
    bool getWaiting();
    int getLaps();
    int getFirstLapTime();
    int getEnergy();
    int getWaitingTime();

    //Setter function
    void setWaiting(bool input);

private:
    CarColor color;
    int velocity;
    int defaultPos;
    Direction direction;
    int startTime;

    int currentPos;
    int laps;
    int firstLapTime;
    int energy;
    int waitingTime;

    bool waiting;
    bool waiting_previous;

    //Convert the degree value to be in [0..360[ range
    int convertDegree(int deg);
};

